/***************************************************************************
 *   Copyright (C) 2004-2005 by Alexander Saal                                  *
 *   alex.saal@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DOSBOXFE_H
#define DOSBOXFE_H

#include "dbfe_maindlg.h"

class QProcess;
class QStringList;
class QListViewItem;
class QNetworkOperation;
class QUrlOperator;

class DosBoxFE : public DBFE_MainDlg
  {
    Q_OBJECT

  public:
    DosBoxFE(QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~DosBoxFE();

    // this start dosbox ( dosbox must be installed ), a simple solution, a better solution follows
    QProcess *db_start;

    // this is for dosbox (cvs version)
    QProcess *db_start_cvs;

    // this verify dosbox, it's a cvs version is this ok ....( for choose the cvs version of dosbox )
    QProcess *db_check_dbox_binary_cvs;

    // this examined whether an update is available
    QProcess *verify_update;

    //Check version from DOSBox binary
    QProcess *db_version;

    // this download the update
    QUrlOperator *download_update;

    // this is for arguments btw commands
    QStringList db_with_config_current, db_with_config_cvs, dbox_check, dbox_version;

  public slots:

    // Create a Gameprofile
    void          slot_Add_GameProfile();

    // button disabeld but available
    void          slot_Open_Config();

    // Save a config into a file :)
    void          slot_Save_Config();

    // This Button ( is clicked ) start DOSBox
    void          slot_Start_DosBox();

    // Output from DOSBox and DBoxFE
    void          slot_ReadStdout_DosBox();

    // Output from DOSBox and DBoxFE ( CVS version )
    void          slot_ReadStdout_DosBox_CVS();

    // Output from DOSBox and DBoxFE ( CVS version )
    void          slot_ReadStdout_DosBox_Version();

    // Remove Gameprofile
    void          slot_Remove_GameProfile();

    // Remove dir from ListBox
    void          slot_Remove_AutoexecDir();

    // Open Download Game Dialog
    void          slot_Game_Download();

    // Add entry from Linedit into Autoexec Listbox
    void          slot_Add_Directory();

    // Choose Directory for mount into DOSBox
    void          slot_Choose_Mount_Directory();

    // Select a SnapDir directory
    void          slot_Choose_SnapDir();

    // Download Update
    void          slot_Download_Update();

    // Verify Update
    void          slot_Verify_Update();

    // Choose dosbox binary ( stabel version )
    void          slot_Choose_DBox_Binary_Curr();

    // Choose dosbox binary ( cvs version )
    void          slot_Choose_DBox_Binary_CVS();

    // For contextmenu in the GUI (create and remove gameprofile)
    void          contextMenuEvent ( QContextMenuEvent * );

    // for information about download status
    void          slot_Update_Progress( int, int, QNetworkOperation * );

    // Choose Gamefile (*.exe etc)
    void          slot_Choose_Game_File();

    // Add Gamefile into the ListBox
    void          slot_Add_Game_File();

    // Remove Gamefile from ListBox
    void          slot_Remove_Game_File();

    // Change or update gamefile ( nothing, coming soon)
    void          slot_Change_Game_File();

    // Add savegamedir
    void          slot_Add_Savegame_Dir();

    // Remove savegamedir from ListBox
    void          slot_Remove_Savegame_Dir();

    // Choose savegamedir
    void          slot_Choose_Savegame_Dir();
    
    // open Gamesearch Wizard
    void          slot_SearchGame();

    // Quit the Application
    void	  slot_Quit();
    
    // red new version
    void          slot_ReadVersion();

  protected:


  protected slots:


  };

#endif
