/***************************************************************************
 *   Copyright (C) 2004-2005 by Alexander Saal                                  *
 *   alex.saal@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "dosboxfe_profile.h"
#include "dosboxfe.h"

#include <qlistbox.h>
#include <qlineedit.h>

#include <kmessagebox.h>
#include <kdebug.h>
#include <kglobal.h>
#include <klocale.h>


DosBoxFE_Profile::DosBoxFE_Profile(QWidget* parent, const char* name, bool modal, WFlags fl)
    : DBFE_ProfileDlg(parent,name, modal,fl)
{}

DosBoxFE_Profile::~DosBoxFE_Profile()
{}

void DosBoxFE_Profile::slot_Abort()
{
  this->close();
}

void DosBoxFE_Profile::slot_Ok()
{
  if ( LineEdit_ProfileName->text().isEmpty() )
    {
      KMessageBox::information( this, i18n("Please enter you Profile name!") );
    }
  else
    {
      QDialog::accept();
      kdDebug() << i18n("Game Profile: ") << LineEdit_ProfileName->text() << i18n(" created") << endl;
    }
}



#include "dosboxfe_profile.moc"
