

/***************************************************************************
 *   Copyright (C) 2004-2005 by Alexander Saal                             *
 *   alex.saal@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "dosboxfe.h"

#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <kconfig.h>
#include <kapp.h>
#include <kstandarddirs.h>

#include <qcheckbox.h>
#include <qsplashscreen.h>


static const char description[] =
  I18N_NOOP("A KDE KPart Application");

static const char version[] = "0.0.6-0.63";

static KCmdLineOptions options[] =
  {
    //    { "+[URL]", I18N_NOOP( "Document to open." ), 0 },
    KCmdLineLastOption
  };

int main(int argc, char **argv)
{
  KAboutData about("DosBox Frontend", I18N_NOOP("DosBox Frontend"), version, description,
                   KAboutData::License_GPL, "(C) 2004 Alexander Saal", 0, 0, "alex.saal@gmx.de");
  about.addAuthor( "Alexander Saal", 0, "alex.saal@gmx.de" );
  KCmdLineArgs::init(argc, argv, &about);
  KCmdLineArgs::addCmdLineOptions( options );
  KApplication app;

  DosBoxFE dbfe;
  KConfig *splashConf( kapp->config() );
  splashConf = new KConfig("dboxferc");
  splashConf->setGroup( "Splashscreen" );

  if ( splashConf->readBoolEntry("Splash", dbfe.chBox_DisableSplash->isChecked() ) )
    {
      DosBoxFE *mainWin = 0;
      mainWin = new DosBoxFE();
      app.setMainWidget( mainWin );
      mainWin->show();
    }
  else
    {
      QPixmap pm;
      pm.load(locate("data", "dboxfe/pics/dbfe.png"));

      QSplashScreen *splash = new QSplashScreen( pm );
      splash->show();

      app.processEvents();

      KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

      if ( args->count() == 0 )
        {
          DosBoxFE *mainWin = 0;
          mainWin = new DosBoxFE();
          app.setMainWidget( mainWin );
          mainWin->show();
        }
      else
        {
	  int i = 0;
          for (; i < args->count() ; i++ )
            {
              DosBoxFE *mainWin = 0;
              mainWin = new DosBoxFE();
              app.setMainWidget( mainWin );
              mainWin->show();
            }
        }
      delete splash;
      args->clear();
    }
  return app.exec();
}
