/***************************************************************************
 *   Copyright (C) 2004-2005 by Alexander Saal                             *
 *   alex.saal@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*************************
 * self include            *
 *************************/
#include "doxboxfe_wizard.moc"
#include "doxboxfe_wizard.h"
#include "dosboxfe_log.h"
#include "gamesearch.h"

/*****************************
 * Min. KDE 3.x.x include *
 ****************************/
#include <kconfig.h>
#include <kapp.h>
#include <kmessagebox.h>
#include <kdebug.h>
#include <kglobal.h>
#include <klocale.h>

/**************************
 * Min. Qt 3.x.x include *
 **************************/
#include <qdir.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qprocess.h>
#include <qstringlist.h>
#include <qstring.h>
#include <qlabel.h>
#include <qlistbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qprogressbar.h>
#include <qradiobutton.h>
#include <qwidget.h>
#include <qframe.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qfileinfo.h>

unsigned long totalBytes = 0, fileNumber = 0;
/*
  LBox_FoundGames
  LBox_NewGames
*/
DoxBoxFE_Wizard::DoxBoxFE_Wizard(QWidget* parent, const char* name, bool modal, WFlags fl)
    : DBFE_Wizard(parent,name, modal,fl)
{}

DoxBoxFE_Wizard::~DoxBoxFE_Wizard()
{}

void DoxBoxFE_Wizard::slot_SaveConfig()
{}

void DoxBoxFE_Wizard::slot_Search()
{
  searchGameFile( LEdit_ChooseGameDir->text() );
}

void DoxBoxFE_Wizard::slot_ChooseGameDir()
{
  QString txt( i18n("Choose Game directory") );

  QFileDialog* fd = new QFileDialog( this, txt, TRUE );
  QString fileName;

  fd->setMode( QFileDialog::DirectoryOnly );
  fd->setDir( QDir::homeDirPath() );
  fd->setShowHiddenFiles( false );
  fd->show();

  if ( fd->exec() == QDialog::Accepted )
    fileName = fd->selectedFile();
  LEdit_ChooseGameDir->setText(fileName);
}

void DoxBoxFE_Wizard::slot_ReadSearch_Out()
{}

void DoxBoxFE_Wizard::searchGameFile( QString dirName )
{
  uint g;
  QDir dir( dirName );
  dir.setFilter( QDir::Files | QDir::Dirs );
  dir.setSorting( QDir::Name );

  QFileInfo *fi;
  const QFileInfoList *fil = dir.entryInfoList();
  QFileInfoListIterator it( *fil );

  while (( fi = it.current() ))
    {
      if ( fi->fileName() == "." || fi->fileName() == ".." )
        ;
      else
        {
          if ( fi->isDir() && fi->isReadable() )
            searchGameFile( fi->absFilePath() );
          else
            {
              g = fi->size();
              QFile f( dirName + maniac2 );
              kdDebug() << g << endl;
              //printf((const char *)fi->absFilePath(), g);

              totalBytes += g;
              pBar_Scan->setProgress( ((const char *)fi->absFilePath(), g) );


              if ( f.exists() )
                {
                  LBox_FoundGames->insertItem("Maniac Mansion 2");
                }
              fileNumber++;
            }
          pBar_Scan->setProgress(100);
        }
      ++it;
    }
}