/***************************************************************************
 *   Copyright (C) 2004-2005 by Alexander Saal                             *
 *   alex.saal@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DOSBOXFE_UPDATEWIZARD_H
#define DOSBOXFE_UPDATEWIZARD_H

#include "dbfe_updatewizard.h"
#include <qprocess.h>
#include <qstringlist.h>
#include <qdir.h>
#include <qstring.h>

class QNetworkOperation;
class QUrlOperator;

class DosBoxFE_UpdateWizard : public DBFE_UpdateWizard
{
        Q_OBJECT

public:
        DosBoxFE_UpdateWizard(QWidget* parent = 0, const char* name = 0, bool modal = TRUE, WFlags fl = 0 );
        ~DosBoxFE_UpdateWizard();

        QUrlOperator *download_suse;
        QUrlOperator *download_debian;
        QUrlOperator *download_debian_src;
        QUrlOperator *download_src;

        QProcess *installSUSE;
        QProcess *installDEB;
        QProcess *installDEB_SRC;
        QProcess *installSRC;

        QStringList inst_suse_lst, inst_deb_lst, inst_deb_src_lst, inst_src_lst;

        QString file, str_ver, uDir,
        uFile_HTTP_SUSE, uFile_SUSE,  // for download suse package
        uFile_HTTP_DEB, uFile_DEB,  // for download debian package
        uFile_HTTP_DEB_SRC, uFile_DEB_SRC, // for download debian-source package
        uFile_HTTP_SRC, uFile_SRC,  // for download source package
        DEB, DEB_PARAM, RPM, RPM_PARAM;

        QDir cDir;     // for create a directory

public slots:

        void slot_Install();
        void slot_Update_Progress( int, int, QNetworkOperation * ); // for information about download status
        void slot_Choose_TAR();

        void slot_Install_SuSE();
        void slot_Install_DEB();
        void slot_Install_DEB_SRC();
        void slot_Install_SRC( QString &dirName, QString &fileName );

        void slot_Install_SuSE_StdOut();
        void slot_Install_DEB_StdOut();
        void slot_Install_DEB_SRC_StdOut();
        void slot_Install_SRC_StdOut();

protected:


protected slots:

};

#endif